<template>
	<!-- 订单搜索 -->
	<view>
		<u-navbar title="" autoBack placeholder>
			<view class="u-nav-slot nav_center" slot="center">
				<view style="width: calc(100% - 90rpx);">
					<u-search v-model="keyword" :focus="true" shape="square" placeholder="请输入运单号搜索" @custom="searchBank"
						@search="searchBank" @clear="clear"></u-search>
				</view>
			</view>
		</u-navbar>
		<view v-if="orderList.length > 0">
			<x-orderManagement ref="order" :orderList="orderList" @sendOrders="sendOrders"
				@operateSuccessfully="operateSuccessfully" @proofRenewal="proofRenewal"
				:key="keyId"></x-orderManagement>
		</view>
		<u-empty mode="search" marginTop="50" v-else></u-empty>
		<u-popup :show="sendShow" closeable round="8" :closeOnClickOverlay="false" @close="close">
			<view class="card_send">
				<view class="send_title">派单</view>
				<view class="card_input_send">
					<view class="incubator_title"><span>*</span>保温箱</view>
					<view class="card_search_gray frame" @click="focus(false)">
						<span v-if="incubator.name">{{incubator.name}}</span>
						<span class="title_gray" v-else>请选择保温箱</span>
						<u-icon name="arrow-down" color="#c8c9cc" size="18"></u-icon>
					</view>
				</view>
				<view class="card_input_send">
					<view class="incubator_title"><span>*</span>冰排编号</view>
					<u-input placeholder="请输入冰排编号" border="surround" v-model="iceNumber" @blur="iceRaftBlur">
						<template slot="suffix">
							<u-icon name="scan" size="24" @click="sweep"></u-icon>
						</template>
					</u-input>
					<view class="add_card center_in" @click="addIce">
						<u-icon name="plus" size="18"></u-icon>
					</view>
				</view>
				<view class="card_frequency">
					<view class="card_high space_between">
						<view class="card_frequency_title">已扫冰排编号</view>
						<view class="card_bottle">已扫<span>{{iceList.length}}</span></view>
					</view>
					<scroll-view :scroll-top="scrollTop" scroll-y="true" class="swept_card">
						<view class="scrollView" style="width: 100%;" v-if="iceList.length > 0">
							<view class="item_coding" v-for="(item,index) in iceList" :key="index">
								<view style="display: flex;align-items: center;">
									<view class="num_index">{{index + 1}}</view>
									<view class="title_coding">{{item}}</view>
								</view>
								<u-icon name="close-circle-fill" color="#c0c4cc" size="20"
									@click="removeWaybill(item)"></u-icon>
							</view>
						</view>
					</scroll-view>
				</view>
				<view style="width: 100%;height: 120rpx;"></view>
				<view class="card_btn">
					<u-button type="primary" text="确定" @click="confirm"></u-button>
				</view>
			</view>
		</u-popup>
	</view>
</template>

<script>
	export default {
		data() {
			return {
				keyword: '',
				loadingMore: true,
				orderList: [],
				incubator: {
					id: null,
					name: '',
				},
				sendShow: false,
				iceNumber: '',
				iceList: [],
				scrollTop: null,
				keyId: 0,
				waybillId: null,
			}
		},
		beforeDestroy() {
			// console.log('页面销毁')
			this.getempty()
		},
		onShow() {
			let incubator = uni.getStorageSync('incubatorValue')
			if (incubator) {
				this.incubator.id = incubator.id
				this.incubator.name = incubator.name
			}
		},
		methods: {
			getempty() {
				this.iceList = []
				this.incubator.id = ''
				this.incubator.name = ''
				this.iceNumber = ''
				uni.removeStorageSync('incubatorValue');
				this.hintTitle = '请选择保温箱'
				this.sendShow = false
				this.incubatorMore = true
				this.thermostatList = []
			},
			searchBank(event) {
				this.orderList = []
				this.loadingMore = true;
				this.$api.get('/api/waybill', {
					waybillNo: this.keyword,
				}).then(res => {
					if (res.code == 200) {
						const data = res.data.list
						if (this.loadingMore == true && data) {
							this.orderList = this.orderList.concat(data);
						}
						if (data.length < this.pageSize) {
							this.loadingMore = true
						} else {
							this.loadingMore = false
						}
					}
				}).catch(() => {
					this.loadingMore = true
				})
			},
			// 移除错误运单号
			removeWaybill(value) {
				if (this.iceNumber == value) {
					this.iceNumber = ''
				}
				const arr = deleteElementById(this.iceList, value)
				this.iceList = arr

				function deleteElementById(arr, key) {
					return arr.filter((item) => item !== key);
				}
			},
			// 添加冰排 
			addIce() {
				if (this.iceNumber) {
					this.iceList.push(this.iceNumber)
					this.iceList = this.uniqueArray(this.iceList)
					this.$nextTick(() => {
						// 获取scroll-view的高度
						const query = uni.createSelectorQuery().in(this);
						query.select('.scrollView').boundingClientRect(data => {
							this.scrollTop = data.height;
						}).exec();
					});
					this.iceNumber = ''
				}
			},
			// 冰排失去焦点
			iceRaftBlur(value) {
				if (value) {
					this.iceList.push(value)
					this.iceList = this.uniqueArray(this.iceList)
				}
			},
			// 去重
			uniqueArray(arr) {
				return [...new Set(arr)];
			},
			// 确定派单
			confirm() {
				if (this.incubator.id) {
					if (this.iceList.length > 0) {
						const arr = []
						arr.push(this.waybillId)
						this.$api.post('/api/waybill/delivery', {
							waybillIds: arr,
							coolerBoxId: this.incubator.id,
							iceRaftCode: this.iceList,
						}).then(res => {
							if (res.code == 200) {
								uni.$u.toast(res.msg)
								this.sendShow = false
								this.tabClick()
							} else if (res.code == 2000) {
								let arrTitle = res.data
								let title = ' ,请将冰排' + arrTitle.toString() + '重新入库'
								uni.$u.toast(res.msg + title)
								this.sendShow = false
								this.tabClick()
							} else {
								uni.$u.toast(res.msg)
							}
						})
					} else {
						uni.$u.toast('请先扫描冰排')
					}
				} else {
					uni.$u.toast('请先选择保温箱')
				}
			},
			// tab运单
			tabClick(row) {
				this.keyId = row.index
				this.loadingMore = true
				this.orderList = []
				this.searchBank()
				this.getempty()
			},
			// 扫一扫
			sweep() {
				// 允许从相机和相册扫码
				uni.scanCode({
					scanType: ['barCode'],
					// scanType: ['qrCode'],
					autoZoom: false,
					success: (res) => {
						console.log(res);
						if (res.result) {
							let url = res.result;
							this.iceNumber = url
							this.iceList.push(url)

							function methods1(arr) {
								return Array.from(new Set(arr));
							}
							this.iceList = methods1(this.iceList)
						} else {
							console.log('请重新扫描');
							return false;
						}
					},
					fail: (res) => {
						console.log('未识别到二维码');
					}
				})
			},
			// 鼠标聚焦
			focus() {
				uni.navigateTo({
					url: '/pages/order/Incubator'
				});
			},
			// 派单
			sendOrders(value) {
				this.waybillId = value.id
				this.sendShow = true
			},
			// 重新获取列表
			operateSuccessfully() {
				this.orderList = []
				this.searchBank()
			},
			// 防拆更新
			proofRenewal() {
				this.orderList = []
				this.searchBank()
			},
			clear() {
				console.log(2)
				this.keyword = ''
			},
			close() {
				this.getempty()
			},
		}
	}
</script>

<style lang="scss">
	.nav_center {
		display: flex;
		align-items: center;
		justify-content: flex-end;
		padding-right: 30rpx;
		width: 100%;
	}

	.card_send {
		padding: 20rpx;
		min-height: 600rpx;
	}

	.send_title {
		text-align: center;
		margin: 10px;
	}

	.card_input_send {
		position: relative;
		display: flex;
		align-items: center;
		margin-bottom: 20rpx;
	}

	.incubator_title {
		width: 150rpx;
		margin-right: 10rpx;
		font-size: 30rpx;

		span {
			color: red;
		}
	}

	.add_card {
		margin-left: 10rpx;
		width: 50rpx;
		height: 46rpx;
		border-radius: 8rpx;
		padding: 6px 9px;
		border: 1px solid #dadbde;
	}

	.card_btn {
		position: absolute;
		bottom: 20rpx;
		left: 30rpx;
		right: 30rpx;
		padding: 20rpx 0rpx;
	}

	.scroll-view {
		transition: max-height 1s ease-out;
		max-height: 0;
		overflow: hidden;
	}

	.card_frequency {
		display: flex;
		flex-wrap: wrap;
	}

	.swept_card {
		padding: 0rpx 20rpx;
		width: calc(100% - 40rpx);
		max-height: 600rpx;
		// overflow-y: auto;
	}

	.card_high {
		margin-bottom: 20rpx;
	}

	.card_frequency_title {
		font-size: 32rpx;
	}

	.card_bottle {
		font-size: 30rpx;

		span {
			color: red;
		}
	}

	.item_coding {
		display: flex;
		justify-content: space-between;
		align-items: center;
		width: 100%;
		padding: 20rpx 0rpx;
	}

	.num_index {
		font-size: 30rpx;
		margin-right: 10rpx;
	}

	.title_coding {
		font-size: 30rpx;
	}


	.card_search_gray {
		display: flex;
		flex-direction: row;
		align-items: center;
		justify-content: space-between;
		flex: 1;
		padding: 12rpx 18rpx;
		border-radius: 8rpx;
		line-height: 48rpx;
	}

	.title_gray {
		font-size: 30rpx;
		color: #c8c9cc;
	}

	// 伪元素1rpx边框
	.frame {
		position: relative; //重要
	}

	.frame::after {
		position: absolute;
		content: '';
		border: 2rpx solid #e7e6e4;
		border-radius: 16rpx;
		width: 200%;
		height: 200%;
		top: 0;
		left: 0;
		transform: scale(0.5);
		transform-origin: 0 0;
		pointer-events: none;
		/* 使伪元素不会阻止鼠标事件 */
	}
</style>